without warning
include keyread.e
include pcsounds.e
include graphics.e
include font.e
include get.e
include image.e
sequence setup
constant UP_ARROW = 328, DOWN_ARROW = 336, ENTER = 28
constant GO_RIGHT = 1, GO_LEFT = 2, GO_UP = 3, GO_DOWN = 4, RUN = 5, BLOCK = 6,
FIRE = 7, CHANGE_WEAPON = 8
constant WEAPON_NAME = 1, WEAPON_HITPOINTS = 2, WEAPON_SHIELD = 3,
WEAPON_RANGE = 4, WEAPON_TYPE = 5
constant AIR = 1, CLOSE = 2
constant WEAPONS = {
{"Sword",10,{5,75},10,CLOSE},
{"Bow",10,{1,5},200,AIR},
{"Spear",10,{5,50},25,CLOSE},
{"Shield",1,{90,90},5,CLOSE}}
puts(1,"Battle! version 1.0 beta. Sorry if it's slow or flickers.\nBattle! initalization sequence\nLoading configuration...")
procedure loadSetup()
    integer f
    f = open("setup.dat","r")
    if f = -1 then
	setup = {{331,333,UP_ARROW,DOWN_ARROW,54,335,28,337},{30,31,17,44,42,56,29,57}}
    else
	setup = get(f)
	if setup[1] != GET_SUCCESS then
	    setup = {{331,333,UP_ARROW,DOWN_ARROW,54,335,28,337},{30,31,17,44,42,56,29,57}}
	else
	    setup = setup[2]
	end if
	close(f)
    end if
end procedure
loadSetup()
puts(1,'\n')
procedure writeSetup()
    integer f
    f = open("setup.dat","w")
    if f != -1 then
	print(f,setup)
	close(f)
    end if
end procedure
puts(1,"Loading fonts.")
constant ARIAL20 = load_font("arial20.f")
puts(1,'.')
constant ARIAL12 = load_font("arial12.f")
puts(1,".\n")
function fix_bitmap(sequence in)
    puts(1,'.')
    return not in[2]
end function
puts(1,"Loading images")
constant SPRITES = {{fix_bitmap(read_bitmap("guysword.bmp")),fix_bitmap(read_bitmap("usesword.bmp"))},
{fix_bitmap(read_bitmap("guybow.bmp")),fix_bitmap(read_bitmap("usebow.bmp"))},
{fix_bitmap(read_bitmap("guyspear.bmp")),fix_bitmap(read_bitmap("usespear.bmp"))},
{fix_bitmap(read_bitmap("guyshield.bmp")),fix_bitmap(read_bitmap("useshield.bmp"))}}
select_font(ARIAL12)
set_background(0)
set_foreground(1)
function allStrings(sequence msg)
    sequence s, imgs
    imgs = repeat(0,101)
    for i = 0 to 100 do
	s = images(sprintf("%d%% " & msg,i))
	s = s[1]
	for j = 1 to length(s) do
	    s[j] &= repeat(0,100-length(s[j]))
	end for
	imgs[i+1] = s
	puts(1,'.')
    end for
    return imgs
end function
function allWeapons()
    sequence imgs, s
    imgs = repeat(0,length(WEAPONS))
    for i = 1 to length(WEAPONS) do
	s = images(WEAPONS[i][1])
	s = s[1]
	for j = 1 to length(s) do
	    s[j] &= repeat(0,100-length(s[j]))
	end for
	imgs[i] = s
	puts(1,'.')
    end for
    return imgs
end function
puts(1,"\nStoring fonts(1/3)")
constant HEALTHS = allStrings("health")
puts(1,"\nStoring fonts(2/3)")
constant STRENGTHS = allStrings("strength")
puts(1,"\nStoring fonts(3/3)")
constant WEAPON_IMGS = allWeapons()
puts(1,"\n")
if graphics_mode(18) then
end if
constant VIDEO_CONFIG = video_config()
constant SPLASH1 = "Jeff's Software Presents..."
constant SPLASH2 = "BATTLE!"
constant CENTER_X = 320, CENTER_Y = 240
procedure delay(atom len)
    atom t
    t = time()
    while len > time()-t do
    end while
end procedure
procedure DisplaySplash()
    sound(0)
    play(zhoup)
    bk_color(BLUE)
    select_font(ARIAL20)
    set_attributes(BOLD)
    set_foreground(YELLOW)
    set_background(BLUE)
    setx(CENTER_X)
    sety(CENTER_Y-15)
    justify(CENTRE)
    write(SPLASH1)
    delay(1)
    clear_screen()
    bk_color(BLACK)
    set_background(BLACK)
    set_foreground(RED)
    setx(CENTER_X)
    sety(CENTER_Y-15)
    write(SPLASH2)
    delay(1)
end procedure
constant MAIN_MENUS = {
(YELLOW+256) & "New Game\n" & (RED+256) & "Setup\nExit",
(RED+256) & "New Game\n" & (YELLOW+256) & "Setup\n" & (RED+256) & "Exit",
(RED+256) & "New Game\nSetup\n" & (YELLOW+256) & "Exit"}
constant ASK_EXIT = {
{"Can't stand the heat?","Get out of the flames.","Bring it on!"},
{"This is such a cool game. Sure you want to quit?","Yes.","No."},
{"I fart in your general direction.","Run away! Run away!","I've got an idea."},
{"Why that's no ordinary rabbit.","Run away! Run away!","Get the holy hand grenade."},
{"Bring out you're dead. Here's one...","Thump","I'm not dead."}}
constant NAMES1 = {"1","2","3","4","5","6","7","8","9","0","-","+","BACKSPACE","TAB","q","w","e","r","t","y","u","i","o","p","[","]","ENTER"}
constant NAMES2 = {"a","s","d","f","g","h","j","k","l",";","'"}
constant NAMES3 = {"z","x","c","v","b","n","m",",",".","/","RIGHT SHIFT"}
constant NAMES4 = {"NUM 7","NUM 8","NUM 9","NUM -","NUM 4","NUM 5","NUM 6","NUM +","NUM 1","NUM 2","NUM 3","NUM 0","NUM ."}
function keyname(integer key)
    if key >= 59 and key <= 68 then
	return sprintf("F%d",key-58)
    elsif key = 41 then
	return '`'
    elsif key = 42 then
	return "LEFT SHIFT"
    elsif key >= 2 and key <= 28 then
	return NAMES1[key-1]
    elsif key >= 30 and key <= 40 then
	return NAMES2[key-29]
    elsif key >= 44 and key <= 54 then
	return NAMES3[key-43]
    elsif key = 29 then
	return "LEFT CTRL"
    elsif key = 56 then
	return "LEFT ALT"
    elsif key = 57 then
	return "SPACE"
    elsif key = 312 then
	return "RIGHT ALT"
    elsif key = 338 then
	return "INS"
    elsif key = 339 then
	return "DEL"
    elsif key = UP_ARROW then
	return "UP"
    elsif key = DOWN_ARROW then
	return "DOWN"
    elsif key = 333 then
	return "RIGHT"
    elsif key = 331 then
	return "LEFT"
    elsif key = 327 then
	return "HOME"
    elsif key = 329 then
	return "PGUP"
    elsif key = 337 then
	return "PGDN"
    elsif key = 335 then
	return "END"
    elsif key = 43 then
	return "\\"
    elsif key = 87 then
	return "F11"
    elsif key = 88 then
	return "F12"
    elsif key = 285 then
	return "RIGHT CTRL"
    elsif key = 309 then
	return "NUM /"
    elsif key = 55 then
	return "NUM *"
    elsif key >= 71 and key <= 83 then
	return NAMES4[key-70]
    elsif key = 284 then
	return "NUM ENTER"
    end if
    return ""
end function
procedure DoExit()
    integer selection, laston, which
    sequence keys
    clear_screen()
    bk_color(BLACK)
    set_foreground(RED)
    set_background(BLACK)
    set_attributes(BOLD)
    laston = 0
    selection = 1
    setx(CENTER_X)
    sety(CENTER_Y-20)
    justify(CENTRE)
    which = rand(length(ASK_EXIT))
    while length(get_keys()) do
    end while
    write(ASK_EXIT[which][1])
    setx(CENTER_X)
    sety(CENTER_Y+10)
    justify(CENTRE)
    write((YELLOW+256) & ASK_EXIT[which][2] & "\n" & (RED+256) & ASK_EXIT[which][3])
    while 1 do
	keys = get_keys()
	if length(keys) and not laston then
	    laston = 1
	    if keys[1] = 1 then
		exit
	    elsif keys[1] = UP_ARROW then
		if selection = 1 then
		    selection = 2
		else
		    selection = 1
		end if
	    elsif keys[1] = DOWN_ARROW then
		if selection = 2 then
		    selection = 1
		else
		    selection = 2
		end if
	    elsif keys[1] = ENTER then
		if selection = 1 then
		    sound(0)
		    play(zhou)
		    if graphics_mode(-1) then
		    end if
		    writeSetup()
		    abort(0)
		else
		    exit
		end if
	    end if
	    setx(CENTER_X)
	    sety(CENTER_Y+10)
	    justify(CENTRE)
	    if selection = 1 then
		write((YELLOW+256) & ASK_EXIT[which][2] & "\n" & (RED+256) & ASK_EXIT[which][3])
	    else
		write((RED+256) & ASK_EXIT[which][2] & "\n" & (YELLOW+256) & ASK_EXIT[which][3])
	    end if
	elsif not length(keys) then
	    laston = 0
	end if
    end while
end procedure
constant OPTIONS = {"Left","Right","Up","Down","Run","Block","Fire","Change Weapon"}
constant SETUP_BUTTONS = {"Ok","Cancel","Restore Defaults"}
procedure DisplaySetup(integer player, integer selection, sequence new, integer hilight)
    setx(20)
    sety(25)
    justify(LEFT)
    for i = 1 to 8 do
	if player = 1 and selection = i then
	    set_foreground(hilight)
	    write(OPTIONS[i] & "\n")
	else
	    set_foreground(RED)
	    write(OPTIONS[i] & "\n")
	end if
    end for
    setx(20)
    sety(185)
    for i = 1 to 8 do
	if player = 2 and selection = i then
	    set_foreground(hilight)
	    write(OPTIONS[i] & "\n")
	else
	    set_foreground(RED)
	    write(OPTIONS[i] & "\n")
	end if
    end for
    setx(10)
    for i = 1 to 3 do
	if player = 3 and selection = i then
	    set_foreground(hilight)
	    write(SETUP_BUTTONS[i] & "\n")
	else
	    set_foreground(RED)
	    write(SETUP_BUTTONS[i] & "\n")
	end if
    end for
    setx(320)
    sety(25)
    justify(RIGHT)
    for i = 1 to 8 do
	if player = 1 and selection = i then
	    set_foreground(hilight)
	    write(keyname(new[1][i]) & "\n")
	else
	    set_foreground(RED)
	    write(keyname(new[1][i]) & "\n")
	end if
    end for
    sety(185)
    for i = 1 to 8 do
	if player = 2 and selection = i then
	    set_foreground(hilight)
	    write(keyname(new[2][i]) & "\n")
	else
	    set_foreground(RED)
	    write(keyname(new[2][i]) & "\n")
	end if
    end for
end procedure
procedure RedisplaySetup()
    clear_screen()
    bk_color(BLUE)
    set_attributes(0)
    set_foreground(RED)
    set_background(BLUE)
    select_font(ARIAL12)
    justify(LEFT)
    setx(10)
    sety(10)
    write("Player 1\n")
    setx(20)
    sety(25)
    write((YELLOW+256) & "Left\n" & (RED+256) & "Right\nUp\nDown\nRun\nBlock\nFire\nChange Weapon\n")
    setx(10)
    write("Player 2\n")
end procedure
procedure RedisplayAllSetup(integer player, integer selection, sequence new, integer hilight)
    integer current_page
    if VIDEO_CONFIG[VC_PAGES] > 1 then
	current_page = get_display_page()
	if current_page = 0 then
	    set_active_page(1)
	    current_page = 1
	else
	    set_active_page(0)
	    current_page = 0
	end if
	RedisplaySetup()
	DisplaySetup(player,selection,new,hilight)
	set_display_page(current_page)
    else
	RedisplaySetup()
	DisplaySetup(player,selection,new,hilight)
    end if
end procedure
function checkSetup(sequence s)
    s = s[1] & s[2]
    for i = length(s) to 1 by -1 do
	if find(s[i],s) != i then
	    return 0
	end if
	if length(keyname(s[i])) = 0 then
	    return 0
	end if
    end for
    return 1
end function
procedure Setup()
    integer player, selection, laston, enter
    sequence keys, new
    new = setup
    player = 1
    selection = 1
    laston = 0
    enter = 0
    RedisplaySetup()
    DisplaySetup(1,1,new,YELLOW)
    while length(get_keys()) do
    end while
    while 1 do
	keys = get_keys()
	if length(keys) and laston = 0 then
	    laston = 1
	    if keys[1] = 1 then
		if enter = 1 then
		    enter = 0
		else
		    exit
		end if
	    elsif keys[1] = DOWN_ARROW then
		if enter = 0 then
		    if player = 1 then
			if selection = 8 then
			    player = 2
			    selection = 1
			else
			    selection += 1
			end if
		    elsif player = 2 then
			if selection = 8 then
			    player = 3
			    selection = 1
			else
			    selection += 1
			end if
		    elsif player = 3 then
			if selection = 3 then
			    player = 1
			    selection = 1
			else
			    selection += 1
			end if
		    end if
		else
		    new[player][selection] = DOWN_ARROW
		    RedisplayAllSetup(player,selection,new,YELLOW)
		    enter = 0
		end if
	    elsif keys[1] = UP_ARROW then
		if enter = 0 then
		    if player = 1 then
			if selection = 1 then
			    player = 3
			    selection = 3
			else
			    selection -= 1
			end if
		    elsif player = 2 then
			if selection = 1 then
			    player = 1
			    selection = 8
			else
			    selection -= 1
			end if
		    elsif player = 3 then
			if selection = 1 then
			    player = 2
			    selection = 8
			else
			    selection -= 1
			end if
		    end if
		else
		    new[player][selection] = UP_ARROW
		    RedisplayAllSetup(player,selection,new,YELLOW)
		    enter = 0
		end if
	    elsif keys[1] = ENTER then
		if player = 3 then
		    if selection = 1 then
			if checkSetup(new) then
			    setup = new
			    exit
			else
			    setx(10)
			    sety(470-baseline_height())
			    justify(LEFT)
			    write("You used a key for more than one action, or used an invalid key.")
			end if
		    elsif selection = 2 then
			exit
		    elsif selection = 3 then
			new = {{331,333,UP_ARROW,DOWN_ARROW,54,335,28,337},{30,31,17,44,42,56,29,57}}
			RedisplayAllSetup(player,selection,new,YELLOW)
		    end if
		else
		    if enter = 0 then
			enter = 1
		    else
			enter = 0
			new[player][selection] = ENTER
			RedisplayAllSetup(player,selection,new,YELLOW)
		    end if
		end if
	    else
		if enter = 1 then
		    enter = 0
		    new[player][selection] = keys[1]
		    RedisplayAllSetup(player,selection,new,YELLOW)
		end if
	    end if
	    if enter = 0 then
		DisplaySetup(player,selection,new,YELLOW)
	    else
		DisplaySetup(player,selection,new,WHITE)
	    end if
	elsif length(keys)=0 then
	    laston = 0
	end if
    end while
end procedure
sequence names, colors
constant COLORS = {"Blue","Green","Cyan","Red","Magenta","Brown","Gray","Bright Blue","Bright Green","Bright Cyan","Bright Red","Bright Magenta","Yellow"}
constant COLOR_LEN = length(COLORS)
function selColor(integer sel)
    if sel < 7 then
	return sel
    else
	return sel + 1
    end if
end function
procedure DisplayColors(integer sel)
    setx(10)
    sety(10+(3*baseline_height()))
    for i = 1 to length(COLORS) do
	if sel = i then
	    set_foreground(BRIGHT_WHITE)
	    write(COLORS[i] & '\n')
	else
	    set_foreground(selColor(i))
	    write(COLORS[i] & '\n')
	end if
    end for
end procedure
sequence health, strength, weapon
integer field_top
procedure WriteNames()
    integer height
    select_font(ARIAL12)
    height = 15+(4*baseline_height())
    field_top = height+1
    polygon(BLACK,1,{{0,0},{640,0},{640,height},{0,height}})
    setx(10)
    sety(10)
    set_foreground(colors[1])
    set_background(BLACK)
    set_attributes(0)
    justify(LEFT)
    write(names[1])
    setx(330)
    set_foreground(colors[2])
    write(names[2])
end procedure
procedure WriteHealth(integer player)
    integer top, bottom, left, right
    sequence img
    select_font(ARIAL12)
    top = 10+baseline_height()
    bottom = top+baseline_height()-1
    if player = 1 then
	left = 10
	right = 320
    else
	left = 330
	right = 640
    end if
    display_image({left,top},HEALTHS[health[player]+1]*colors[player])
end procedure
procedure WriteStrength(integer player)
    integer top, bottom, left, right
    sequence img
    select_font(ARIAL12)
    top = 10+(2*baseline_height())
    bottom = top+baseline_height()-1
    if player = 1 then
	left = 10
	right = 320
    else
	left = 330
	right = 640
    end if
    display_image({left,top},STRENGTHS[strength[player]+1]*colors[player])
end procedure
procedure WriteWeapon(integer player)
    integer top, bottom, left, right
    sequence img
    select_font(ARIAL12)
    top = 13+(3*baseline_height())
    bottom = top+baseline_height()-1
    if player = 1 then
	left = 10
	right = 320
    else
	left = 330
	right = 640
    end if
    display_image({left,top},WEAPON_IMGS[weapon[player]]*colors[player])
end procedure
sequence positions, arrows, stats
procedure DisplayPlayer(integer player, sequence oldpos)
    sequence img
    if not equal(positions[player],oldpos) then
	polygon(WHITE,1,{oldpos,{oldpos[1]+40,oldpos[2]},oldpos+40,{oldpos[1],oldpos[2]+40}})
    end if
    img = colors[player]*SPRITES[weapon[player]][stats[player]+1]
    for i = 1 to 40 do
	for j = 1 to 40 do
	    if img[i][j] = 0 then
		img[i][j] = WHITE
	    end if
	end for
    end for
    display_image(positions[player],img)
end procedure
function GameMenu()
    integer selection, laston
    sequence keys
    select_font(ARIAL20)
    set_background(CLEAR)
    setx(320)
    sety(240-baseline_height())
    justify(CENTRE)
    laston = 0
    set_foreground(YELLOW)
    write("Return to game\n")
    set_foreground(RED)
    write("End game")
    selection = 1
    while length(get_keys()) do
    end while
    while 1 do
	keys = get_keys()
	if laston=0 and length(keys) then
	    laston=1
	    if keys[1] = 1 then
		while length(get_keys()) do
		end while
		return 0
	    elsif keys[1] = DOWN_ARROW or keys[1] = UP_ARROW then
		if selection = 1 then
		    selection = 2
		else
		    selection = 1
		end if
		setx(320)
		sety(240-baseline_height())
		justify(CENTRE)
		if selection = 1 then
		    set_foreground(YELLOW)
		    write("Return to game\n")
		    set_foreground(RED)
		    write("End game")
		else
		    set_foreground(RED)
		    write("Return to game\n")
		    set_foreground(YELLOW)
		    write("End game")
		end if
	    elsif keys[1] = ENTER then
		while length(get_keys()) do
		end while
		if selection = 1 then
		    return 0
		else
		    return 1
		end if
	    end if
	elsif length(keys)=0 then
	    laston=0
	end if
    end while
    return 0
end function
constant NORM_SPEED = 0.01
function oppose(integer n)
    if n = 1 then
	return 2
    else
	return 1
    end if
end function
procedure DoVictory(integer j)
    select_font(ARIAL20)
    set_attributes(BOLD)
    set_foreground(RED)
    set_background(CLEAR)
    justify(CENTRE)
    setx(320)
    sety(240-floor(baseline_height()*1.5))
    write(names[oppose(j)] & " dies.\n" & names[j] & " is victorious!\nPress any key.")
    qplay(zap)
    while length(get_keys()) = 0 do
    end while
end procedure
procedure PlayGame()
    sequence keys, laston, lastpos
    atom tm, tmcorrect
    integer n
    object temp
    health = {100,100}
    strength = {100,100}
    weapon = {1,1}
    clear_screen()
    polygon(WHITE,1,{{0,0},{640,0},{640,480},{0,480}})
    WriteNames()
    WriteHealth(1)
    WriteHealth(2)
    WriteStrength(1)
    WriteStrength(2)
    WriteWeapon(1)
    WriteWeapon(2)
    positions = {{20,200},{580,200}}
    arrows = {}
    stats = {0,0}
    DisplayPlayer(1,positions[1])
    DisplayPlayer(2,positions[2])
    tm = time()
    laston = {}
    while 1 do
	keys = get_keys()
	if time()-tm != 0 then
	    n = 1
	    while n <= length(laston) do
		if not find(laston[n],keys) then
		    laston = laston[1..n-1] & laston[n+1..length(laston)]
		else
		    n += 1
		end if
	    end while
	    for i = 1 to length(keys) do
		if keys[i] = 1 then
		    tmcorrect = time()
		    temp = save_image({0,0},{639,479})
		    if GameMenu() then
			return
		    end if
		    display_image({0,0},temp)
		    tmcorrect = time()-tmcorrect
		    tm += tmcorrect
		else
		    for j = 1 to 2 do
			if keys[i] = setup[j][CHANGE_WEAPON] and not find(keys[i],laston) then
			    weapon[j] += 1
			    if weapon[j] =5 then
				weapon[j] = 1
			    end if
			    WriteWeapon(j)
			    DisplayPlayer(j,positions[j])
			elsif keys[i] = setup[j][GO_RIGHT] then
			    temp = NORM_SPEED
			    if find(setup[j][RUN],keys) then
				temp /= 2
			    end if
			    lastpos = positions[j]
			    positions[j][1] -= (time()-tm)/temp
			    if positions[j][1] < 0 then
				positions[j][1] = 0
			    end if
			    DisplayPlayer(j,lastpos)
			elsif keys[i] = setup[j][GO_LEFT] then
			    temp = NORM_SPEED
			    if find(setup[j][RUN],keys) then
				temp /= 2
			    end if
			    lastpos = positions[j]
			    positions[j][1] += (time()-tm)/temp
			    if positions[j][1] > 600 then
				positions[j][1] = 600
			    end if
			    DisplayPlayer(j,lastpos)
			elsif keys[i] = setup[j][GO_UP] then
			    temp = NORM_SPEED
			    if find(setup[j][RUN],keys) then
				temp /= 2
			    end if
			    lastpos = positions[j]
			    positions[j][2] -= (time()-tm)/temp
			    if positions[j][2] < field_top then
				positions[j][2] = field_top
			    end if
			    DisplayPlayer(j,lastpos)
			elsif keys[i] = setup[j][GO_DOWN] then
			    temp = NORM_SPEED
			    if find(setup[j][RUN],keys) then
				temp /= 2
			    end if
			    lastpos = positions[j]
			    positions[j][2] += (time()-tm)/temp
			    if positions[j][2] > 440 then
				positions[j][2] = 440
			    end if
			    DisplayPlayer(j,lastpos)
			elsif keys[i] = setup[j][FIRE] and not find(keys[i],laston) then
			    stats[j] = 1
			    DisplayPlayer(j,positions[j])
			    sound(0)
			    play(chang)
			    if sqrt(power(positions[1][1]-positions[2][1],2)+power(positions[1][2]-positions[2][2],2)) <= WEAPONS[weapon[j]][WEAPON_RANGE]+20 then
				if find(setup[oppose(j)][BLOCK],keys) then
				    if rand(100) > WEAPONS[weapon[oppose(j)]][WEAPON_SHIELD][WEAPONS[weapon[j]][WEAPON_TYPE]] then
					health[oppose(j)] -= WEAPONS[weapon[j]][WEAPON_HITPOINTS]
					if health[oppose(j)] <= 0 then
					    DoVictory(j)
					    return
					end if
					WriteHealth(oppose(j))
				    end if
				else
					health[oppose(j)] -= WEAPONS[weapon[j]][WEAPON_HITPOINTS]
					if health[oppose(j)] <= 0 then
					    DoVictory(j)
					    return
					end if
					WriteHealth(oppose(j))
				end if
			    end if
			    stats[j] = 0
			    DisplayPlayer(j,positions[j])
			end if
		    end for
		end if
	    end for
	    laston = keys
	    tm = time()
	end if
    end while
end procedure
procedure NewGame()
    integer selection, laston
    sequence keys
    colors = {0,0}
    while length(get_keys()) do
    end while
    clear_screen()
    bk_color(BLACK)
    setx(10)
    sety(10)
    select_font(ARIAL12)
    set_attributes(0)
    set_foreground(YELLOW)
    set_background(BLACK)
    justify(LEFT)
    write("Player 1 enter your name:")
    names = {"",""}
    setx(200)
    names[1] = prompt("",320)
    if names[1][1] = 27 then
	return
    else
	names[1] = names[1][2]
    end if
    setx(10)
    sety(10+baseline_height())
    write("Player 2 enter your name:")
    setx(200)
    names[2] = prompt("",320)
    if names[2][1] = 27 then
	return
    else
	names[2] = names[2][2]
    end if
    setx(10)
    sety(10+(2*baseline_height()))
    write(names[1] & " select your color.\n")
    selection = 1
    DisplayColors(1)
    laston = 0
    while length(get_keys()) do
    end while
    while 1 do
	keys = get_keys()
	if length(keys) and not laston then
	    laston = 1
	    if keys[1] = 1 then
		return
	    elsif keys[1] = UP_ARROW then
		if selection = 1 then
		    selection = COLOR_LEN
		else
		    selection -= 1
		end if
	    elsif keys[1] = DOWN_ARROW then
		if selection = COLOR_LEN then
		    selection = 1
		else
		    selection += 1
		end if
	    elsif keys[1] = ENTER then
		colors[1] = selColor(selection)
		exit
	    end if
	    DisplayColors(selection)
	elsif not length(keys) then
	    laston = 0
	end if
    end while
    polygon(BLACK,1,{{0,10+(2*baseline_height())},{640,10+(2*baseline_height())},{640,480},{0,480}})
    setx(10)
    sety(10+(2*baseline_height()))
    write(names[2] & " select your color.\n")
    selection = 1
    DisplayColors(1)
    laston = 0
    while length(get_keys()) do
    end while
    while 1 do
	keys = get_keys()
	if length(keys) and not laston then
	    laston = 1
	    if keys[1] = 1 then
		return
	    elsif keys[1] = UP_ARROW then
		if selection = 1 then
		    selection = COLOR_LEN
		else
		    selection -= 1
		end if
	    elsif keys[1] = DOWN_ARROW then
		if selection = COLOR_LEN then
		    selection = 1
		else
		    selection += 1
		end if
	    elsif keys[1] = ENTER then
		colors[2] = selColor(selection)
		exit
	    end if
	    DisplayColors(selection)
	elsif not length(keys) then
	    laston = 0
	end if
    end while
    clear_screen()
    bk_color(BLACK)
    select_font(ARIAL20)
    set_attributes(BOLD)
    set_foreground(RED)
    set_background(BLACK)
    setx(320)
    sety(240-floor(baseline_height()/2))
    justify(CENTRE)
    write("Game starting in 5...")
    delay(1)
    setx(320)
    sety(240-floor(baseline_height()/2))
    justify(CENTRE)
    clear_screen()
    write("Game starting in 4...")
    delay(1)
    setx(320)
    sety(240-floor(baseline_height()/2))
    justify(CENTRE)
    clear_screen()
    write("Game starting in 3...")
    delay(1)
    setx(320)
    sety(240-floor(baseline_height()/2))
    justify(CENTRE)
    clear_screen()
    write("Game starting in 2...")
    delay(1)
    setx(320)
    sety(240-floor(baseline_height()/2))
    justify(CENTRE)
    clear_screen()
    write("Game starting in 1...")
    delay(1)
    setx(320)
    sety(240-floor(baseline_height()/2))
    justify(CENTRE)
    clear_screen()
    write("Game starting...")
    PlayGame()
end procedure
procedure MainMenu()
    integer selection, laston
    sequence keys
    clear_screen()
    bk_color(BLACK)
    set_foreground(RED)
    set_background(BLACK)
    set_attributes(BOLD)
    laston = 0
    selection = 1
    setx(CENTER_X)
    sety(CENTER_Y-20)
    justify(CENTRE)
    write(MAIN_MENUS[selection])
    while 1 do
	keys = get_keys()
	if length(keys) and not laston then
	    laston = 1
	    if keys[1] = 1 then
		DoExit()
		clear_screen()
		select_font(ARIAL20)
		bk_color(BLACK)
		set_foreground(RED)
		set_background(BLACK)
		set_attributes(BOLD)
	    elsif keys[1] = UP_ARROW then
		if selection = 1 then
		    selection = 3
		else
		    selection -= 1
		end if
	    elsif keys[1] = DOWN_ARROW then
		if selection = 3 then
		    selection = 1
		else
		    selection += 1
		end if
	    elsif keys[1] = ENTER then
		if selection = 1 then
		    NewGame()
		elsif selection = 2 then
		    Setup()
		elsif selection = 3 then
		    DoExit()
		end if
		clear_screen()
		select_font(ARIAL20)
		bk_color(BLACK)
		set_foreground(RED)
		set_background(BLACK)
		set_attributes(BOLD)
	    end if
	    setx(CENTER_X)
	    sety(CENTER_Y-20)
	    justify(CENTRE)
	    write(MAIN_MENUS[selection])
	elsif not length(keys) then
	    laston = 0
	end if
    end while
end procedure
DisplaySplash()
MainMenu()

