-- pc speaker effects
-- J. Craig Gilbert
-- cgilbert@cennet.mc.peachnet.edu
-- These sound effects are designed to be used with the play() and
-- qplay() procedures defined in the include file pcspeak.e
--
-- The sound effects defined here were translated from an old BASIC file
-- written by Merlin R. Null in 1987, except for the rendition of
-- 'Blue Peter' (an old hornpipe, also known as the Popeye theme).
-- That was translated from some old 'C' source code, which had errors
-- in it to begin with, so don't be surprised if there are some incorrect
-- octave changes or some such thing in it.
include pcspeak.e
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--------  define some sounds for the play() procedure
global sequence chang, oh, space1, space2, gurgle, spectre, grup1, grup2, 
                chirp, waver, blurp, space3, who1, who2, mew, phone1,
                siren1, zhoup, vrowr, zhou, art, coo, squawk

chang = {}
for i = 1 to 4 do
   for x = 2000 to 400 by -400 do
      chang = chang & {x,.011}
   end for
   for x = 800 to 2000 by 400 do
      chang = chang & {x,.011}
   end for
end for

oh = {}
for x = 800 to 2000 by 100 do
   oh = oh & {x,.011}
end for
for x = 2000 to 100 by -100 do
   oh = oh & {x,.011}
end for

space1 = {}
for x = 1000 to 40 by -20 do
   space1 = space1 & {x,.011}
end for

space2 = {}
for x = 10000 to 500 by -500 do
   space2 = space2 & {x,.011}
end for

gurgle = {}
for x = 10 to 50 by 10 do
   for y = 50 to 10 by -10 do
      gurgle = gurgle & {power(x,2)+power(y,2),.0055}
   end for
end for

spectre = {}
for x = 1 to 30 by .4 do
   spectre = spectre & {floor((sin(x)+40)*50), .011}
end for

grup1 = {}
for x = 10 to 50 by 10 do
   for y = 50 to 10 by -10 do
      grup1 = grup1 & {x*y,.0055}
   end for
end for

grup2 = {}
for x = 30 to 70 by 10 do
   for y = 70 to 30 by -10 do
      grup2 = grup2 & {x*y,.0055}
   end for
end for

chirp = {}
for x = 30 to 60 by 10 do
   for y = 60 to 30 by -10 do
      chirp = chirp & {x*y,.011}
   end for
end for

waver = {}
for x = 1 to 30 by .7 do
   waver = waver & {floor((sin(x)+20)*30),.011}
end for


blurp = {}
for x = 1 to 40 do
   blurp = blurp & {rand(1400)+450,.0055}
end for

who1 = {}
for x = 10.2 to 8.2 by -.2 do
   who1 = who1 & {floor((tan(x)+36)*25),.044} & {floor((sin(x)+20)*50),.022}
end for

who2 = {}
for x = 10.2 to 8.2 by -.2 do
   who2 = who2 & {floor((tan(x)+36)*10),.044} & {floor((sin(x)+20)*20),.022}
end for

mew = {}
for x = 10.8 to 8 by -.1 do
   mew = mew & {floor((tan(x)+50)*25),.022}
end for

phone1 = {}
for x = 1 to 10 do
   phone1 = phone1 & {1195,.022,2571,.022}
end for

siren1 = {550,.49,400,.49}

zhoup = {}
for x = 3 to 9 by .2 do
   zhoup = zhoup & {floor((120 + power(x,4))),.0055,0,.0055}
end for

vrowr = {}
for x = 9 to 3 by -.1 do
   vrowr = vrowr & {floor((120 + power(x,4))),.0055,0,.0055}
end for

zhou = {}
for x = 40 to 15 by -1 do
   for y = 90 to 50 by -10 do
      zhou = zhou & {x*y,.0055}
   end for
end for

art = {}
for x = 1 to 10 do
   art = art & {1195-50*x,.0165, 1195+50*x, .0165}
end for

coo = {}
for x = 0 to 150 by 10 do
   coo = coo & {1295-x,.022,1095+x,.022}
end for

squawk = {}
for x = 1 to 20 do
   for y = 50 to 150 by 50 do
      squawk = squawk & {x*y, .0055}
   end for
end for
------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Some more sounds, in QBASIC format for the qplay() procedure
global constant 
   cuckoo = "T120L16MLO3BF#",
   zap="T255L64MLO4BAGFEDC<BAGFEDEC<BAGFEDC<BAGFEDC<BAGFEDC",
   wolf="T200L64MLO4C#DD#EFF#GG#AA#B>CC#DD#EFP8.<C#DD#EFF#GG#AA#B>CC#DD#EFFED#DC#C<BA#AG#GGF#FED#DC#",
   tifweet="T255L32O4mlDGD<G>DGDDGDGBAGF#EE",
   zang1="T255L64MLO2BCADGEFEGDACBCADGEFEGDACB",
   zang2="T255L64MLO3BCADGEFEGDACBCADGEFEGDACB",
   zang3="T255L64MLO4BCADGEFEGDACBCADGEFEGDACB",
   zang4="T255L64MLO5BCADGEFEGDACBCADGEFEGDACB",
   downer1="T150L64MSO4BGEC<AFL16D",
   downer2="T150L64MSO4BFC<GD<AL16E",
   downer3="T150L64MSO4BE<AD<GC<L32F",
   upScale1="T150L64MSO3DFA>CEGL16B",
   upScale2="T120L64MSO2E.A.>D.G.>C.F.B.",
   upScale3="T150L64MSO0F>CG>DA>EB.",
   tweedle="T240L64MLO4EGEGEGCFCFCFGEGEGE",
   whoople="T255L64O4CDEFGABO3CDEFGABO2CDEFGAB",
   bongee1="T255L64MLO1BAGFEDC<BAGFEDCP16>CDEFGAB>CDEFGABP32",
   bongee2="T255L64MLO2BAGFEDC<BAGFEDCP16>CDEFGAB>CDEFGABP32",
   bongee3="T255L64MLO3BAGFEDC<BAGFEDCP16>CDEFGAB>CDEFGABP32",
   bongee4="T255L64MLO4BAGFEDC<BAGFEDCP16>CDEFGAB>CDEFGABP32",
   uhoh1="T255L64MLO1CDEFGAB>CDEFGABP16<BAGFEDC<BAGFEDCP32",
   uhoh2="T255L64MLO2CDEFGAB>CDEFGABP16<BAGFEDC<BAGFEDCP32",
   uhoh3="T255L64MLO3CDEFGAB>CDEFGABP16<BAGFEDC<BAGFEDCP32",
   uhoh4="T255L64MLO4CDEFGAB>CDEFGABP16<BAGFEDC<BAGFEDCP32",
   bobWhite="T120L16O4C#.P16T255L64mlC#DD#EFF#GG#AA#BO5CC#DD#EF",
   whung="T255L32mlO3CD<CD>>CD<<CD>>CD<<CD>CD",
   phone2="T240L64MLO4EGEGEGEGEGEGEGEGEGEGEGEGEGEGEG",
   tweet="O4T255L64MLB-BB-BAGAG.>EGG>EGG",
   fweet="T255L64MsO4C#DD#EFF#GG#AA#B>CC#DD#EF",
   -- Popeye's theme
   bluePeter="T110L16O4C<B>CP16<L8CCL16GFEG>L8CL16CEDCDP16<L8DDL16DC<B>DL8" &
   "GGL16AB>C<BAGAGFEFEDCDC<BAGAB>CDEFGL8ECC>L16C<B>CP16<L8CCL16C<BAP16L8FF" &
   "L16BO3CDP16L8DDL16DCO2BP16L8GGL16AB>C<BAGAGFEFEDCDC<BAGAB>CDEFGL8ECC"
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------

