function R90(sequence xy)
    return {-xy[2],xy[1]}
end function
function R30(sequence xy)
    return {0.5*xy[1],((sqrt(3)/2)*xy[1])+0.5*xy[2]}
end function
function toPix(sequence xy, sequence center)
    return {center[1]+xy[1],center[2]-xy[2]}
end function
function toXy(sequence xy, sequence center)
    return {xy[1]-center[1],center[2]-xy[2]}
end function
global function rotate(sequence image, object center, integer turn)
    integer r, n
    sequence out
    sequence xy
    if integer(center) then
	center = {length(image[1]),length(image)} / 2
    end if
    out = repeat(repeat(0,length(image[1])),length(image))
    if turn < 0 then
	turn = 360 + turn
    end if
    if remainder(turn,90) = 0 then
	r = routine_id("R90")
	n = turn/90
    elsif remainder(turn,30) = 0 then
	r = routine_id("R30")
	n = turn/30
    else
	return -1
    end if
    for j = 0 to 1 do
	for l = 0 to 1 do
	    xy = toXy({power(length(image[1]),j),power(length(image),l)},center)
	    for k = 1 to n do
		xy = call_func(r,{xy})
	    end for
	    xy = floor(toPix(xy,center))
	    if xy[1] < 1 then
		for i = 1 to length(out) do
		    out[i] = repeat(0,1-xy[1]) & out[i]
		end for
		center[1] = center[1] + (1-xy[1])
	    elsif xy[1] > length(out[1]) then
		for i = 1 to length(out) do
		    out[i] = out[i] & repeat(0,xy[1]-length(out[1]))
		end for
	    end if
	    if xy[2] < 1 then
		for i = 1 to 1-xy[2] do
		    out = prepend(out,repeat(0,length(out[1])))
		end for
		center[2] = center[2] + (1-xy[2])
	    elsif xy[2] < length(out) then
		for i = 1 to xy[2]-length(out) do
		    out = prepend(out,repeat(0,length(out[1])))
		end for
	    end if
	end for
    end for
    for i = 1 to length(image) do
	for j = 1 to length(image[1]) do
	    xy = toXy({j,i},center)
	    for k = 1 to n do
		xy = call_func(r,{xy})
	    end for
	    xy = floor(toPix(xy,center))
	    if xy[1] > 0 and xy[2] > 0 and xy[1] <= length(image[1]) and 
	    xy[2] <= length(image) then
		out[xy[2]][xy[1]] = image[i][j]
	    end if
	end for
    end for
    return out
end function
